| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
cv::xfeatures2d::AffineFeature2D Class Referenceabstract
Extra 2D Features Framework » Experimental 2D Features Algorithms

Class implementing affine adaptation for key points. More...

`#include <opencv2/xfeatures2d.hpp>`

Collaboration diagram for cv::xfeatures2d::AffineFeature2D:

## Public Member Functions
virtual void | detect (InputArray image, std::vector< Elliptic_KeyPoint > &keypoints, InputArray mask=noArray())=0
| Detects keypoints in the image using the wrapped detector and performs affine adaptation to augment them with their elliptic regions.
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant).
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< Elliptic_KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)=0
| Detects keypoints and computes descriptors for their surrounding regions, after warping them into circles.
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant).
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty.
virtual String | getDefaultName () const CV_OVERRIDE
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage.
void | read (const String &fileName)
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual void | save (const String &filename) const
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
static Ptr< AffineFeature2D > | create (Ptr< FeatureDetector > keypoint_detector)
| Creates an instance where keypoint detector and descriptor extractor are identical.
static Ptr< AffineFeature2D > | create (Ptr< FeatureDetector > keypoint_detector, Ptr< DescriptorExtractor > descriptor_extractor)
| Creates an instance wrapping the given keypoint detector and descriptor extractor.
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class implementing affine adaptation for key points.

A FeatureDetector and a DescriptorExtractor are wrapped to augment the detected points with their affine invariant elliptic region and to compute the feature descriptors on the regions after warping them into circles.

The interface is equivalent to Feature2D, adding operations for Elliptic_KeyPoints instead of KeyPoints.

## Member Function Documentation

## ◆ create() [1/2]

static Ptr< AffineFeature2D > cv::xfeatures2d::AffineFeature2D::create | ( | Ptr< FeatureDetector > | keypoint_detector | ) |
| inline static

Creates an instance where keypoint detector and descriptor extractor are identical.

## ◆ create() [2/2]

static Ptr< AffineFeature2D > cv::xfeatures2d::AffineFeature2D::create | ( | Ptr< FeatureDetector > | keypoint_detector,
|  | Ptr< DescriptorExtractor > | descriptor_extractor )
| static

Creates an instance wrapping the given keypoint detector and descriptor extractor.

## ◆ detect() [1/3]

virtual void cv::xfeatures2d::AffineFeature2D::detect | ( | InputArray | image,
|  | std::vector< Elliptic_KeyPoint > & | keypoints,
|  | InputArray | mask = noArray() )
| pure virtual

Detects keypoints in the image using the wrapped detector and performs affine adaptation to augment them with their elliptic regions.

Here is the call graph for this function:

## ◆ detect() [2/3]

virtual void cv::Feature2D::detect | ( | InputArray | image,
|  | std::vector< KeyPoint > & | keypoints,
|  | InputArray | mask = noArray() )
| virtual

Detects keypoints in an image (first variant) or image set (second variant).

Parameters

  image | Image.
  keypoints | The detected keypoints. In the second variant of the method keypoints[i] is a set of keypoints detected in images[i] .
  mask | Mask specifying where to look for keypoints (optional). It must be a 8-bit integer matrix with non-zero values in the region of interest.

Reimplemented from cv::Feature2D.

## ◆ detect() [3/3]

virtual void cv::Feature2D::detect | ( | InputArrayOfArrays | images,
|  | std::vector< std::vector< KeyPoint > > & | keypoints,
|  | InputArrayOfArrays | masks = noArray() )
| virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  images | Image set.
  keypoints | The detected keypoints. In the second variant of the method keypoints[i] is a set of keypoints detected in images[i] .
  masks | Masks for each input image specifying where to look for keypoints (optional). masks[i] is a mask for images[i].

Reimplemented from cv::Feature2D.

## ◆ detectAndCompute() [1/2]

virtual void cv::xfeatures2d::AffineFeature2D::detectAndCompute | ( | InputArray | image,
|  | InputArray | mask,
|  | std::vector< Elliptic_KeyPoint > & | keypoints,
|  | OutputArray | descriptors,
|  | bool | useProvidedKeypoints = false )
| pure virtual

Detects keypoints and computes descriptors for their surrounding regions, after warping them into circles.

## ◆ detectAndCompute() [2/2]

virtual void cv::Feature2D::detectAndCompute | ( | InputArray | image,
|  | InputArray | mask,
|  | std::vector< KeyPoint > & | keypoints,
|  | OutputArray | descriptors,
|  | bool | useProvidedKeypoints = false )
| virtual

Detects keypoints and computes the descriptors

Reimplemented from cv::Feature2D.

The documentation for this class was generated from the following file:

- opencv2/xfeatures2d.hpp